/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef INIT_H
#define INIT_H

#include <glib.h>

#define White_King_Castle 0
#define White_Queen_Castle 1
#define Black_King_Castle 2
#define Black_Queen_Castle 3

extern guint64 squareKey[14][64];
extern guint64 enPassantKey[8];
extern guint64 castleKey[4];
extern guint64 turnKey;
extern gint pvt[14][64][2];
extern guint64 attackPawn[2][64];
extern guint64 attackKnight[64];
extern guint64 attackKing[64];
extern guint8 bitsIn16bits[0x1u << 16];
extern guint64 kingSafeDistance1[64];
extern guint64 kingSafeDistance2[64];
extern guint64 maskKnight[64];
extern guint64 maskBishop[64];
extern guint64 maskRook[64];
extern guint64 maskQueen[64];

#define C64(constant) constant##ull

extern const unsigned int magicmoves_r_shift[64];
extern const guint64 magicmoves_r_magics[64];
extern const guint64 magicmoves_r_mask[64];
extern const guint64* magicmoves_r_indices[64];
extern guint64 magicmovesbdb[5248];
extern const unsigned int magicmoves_b_shift[64];
extern const guint64 magicmoves_b_magics[64];
extern const guint64 magicmoves_b_mask[64];
extern const guint64* magicmoves_b_indices[64];
extern guint64 magicmovesrdb[102400];

void init(GRand* mrand);

#endif
